#include <stdio.h>

/*
	ɃVAʐMp
	o[XgG[͒
	256bit(32oCg)16bit̃`FbNR[h
	65536bit(8KB)EDC
	7%̃I[o[wbh
*/

int encode_edc(unsigned char *src, unsigned char *dst, int size);
int decode_edc(unsigned char *src, unsigned char *dst, int size);

int main(int argc, char **argv)
{
	FILE *fp;
	unsigned char src[256 * 1024], dst[256 * 1024];
	int size;

	if (argc < 4)
		return 1;
	
	fp = fopen(argv[2], "rb");
	size = fread(src, 1, sizeof src, fp);
	fclose(fp);

	if (argv[1][0] == 'e') {
		size = encode_edc(src, dst, size);
	}
	if (argv[1][0] == 'd') {
		size = decode_edc(src, dst, size);
		if (size < 0) {
			puts("decode error");
			return 1;
		}
	}

	fp = fopen(argv[3],"wb");
	fwrite(dst, 1, size, fp);
	fclose(fp);
	return 0;
}

int calc_ed(unsigned char *src)
{
	int i, ed = 0xaa55;
	for (i = 0; i < 32; i += 2)
		ed ^= src[i + 0] | src[i + 1] << 8;
	return ed;
}

int encode_edc(unsigned char *src, unsigned char *dst, int size)
{
	int dsize = 34 * 2, i, j;

	for (j = 0; j < 2; j++) {
		for (i = 0; i < 8; i++) {
			dst[0] = (size >> 24) & 0xff;
			dst[1] = (size >> 16) & 0xff;
			dst[2] = (size >>  8) & 0xff;
			dst[3] =  size        & 0xff;
			dst += 4;
		}
		i = calc_ed(dst - 32);
		dst[0] =  i       & 0xff;
		dst[1] = (i >> 8) & 0xff;
		dst += 2;
	}

	while ((size & 8191) > 0) {
		src[size] = 0;
		size++;
	}
	for (; size > 0; size -= 8192) {
		for (i = 0; i < 64; i++)
			dst[i] = 0;
		for (i = 0; i < 8192; i++)
			dst[i & 63] ^= src[i];
		for (i = 31; i >= 0; i--)
			dst[i + 34] = dst[i + 32];
		for (j = 0; j < 2; j++) {
			i = calc_ed(dst);
			dst[32 + 0] =  i       & 0xff;
			dst[32 + 1] = (i >> 8) & 0xff;
			dst += 34;
		}
		for (j = 0; j < 256; j++) {
			for (i = 0; i < 32; i++)
				dst[i] = src[i];
			i = calc_ed(src);
			dst[32 + 0] =  i       & 0xff;
			dst[32 + 1] = (i >> 8) & 0xff;
			dst += 34;
			src += 32;
		}
		dsize += 34 * 258;
	}
	return dsize;
}

int decode_edc(unsigned char *src, unsigned char *dst, int size)
{
	int dsize = 0, i, j, k;
	unsigned char *p[2], *q[2], elect[256];
	if (size < 34 * 2)
		return -1;
	for (i = 0; i < 4; i++) {
		for (j = 0; j < 256; j++)
			elect[j] = 0;
		for (j = 0; j < 8; j++)
			elect[src[j * 4 + i]]++;
		for (j = 0; j < 8; j++)
			elect[src[34 + j * 4 + i]]++;
		k = 0;
		for (j = 1; j < 256; j++) {
			if (elect[k] < elect[j])
				k = j;
		}
		dsize = dsize << 8 | k;
	}
	if (size < ((dsize + 8191) >> 13) * (34 * 258))
		return -1;

	src += 34 * 2;
	size = (dsize + 8191) & ~8191;
	for (; size > 0; size -= 8192) {
		p[0] = src;
		if (calc_ed(src) != (src[32 + 0] | src[32 + 1] << 8))
			p[0] = NULL;
		src += 34;
		p[1] = src;
		if (calc_ed(src) != (src[32 + 0] | src[32 + 1] << 8))
			p[1] = NULL;
		src += 34;
		q[0] = q[1] = NULL;
		for (j = 0; j < 256; j++) {
			for (i = 0; i < 32; i++)
				dst[i] = src[i];
			if (calc_ed(src) != (src[32 + 0] | src[32 + 1] << 8)) {
				if (q[j & 1] == NULL)
					q[j & 1] = dst;
				else
					return -1;
			} else if (p[j & 1] != NULL) {
				for (i = 0; i < 32; i++)
					p[j & 1][i] ^= src[i];
			}
			src += 34;
			dst += 32;
			if (q[0] != NULL) {
				if (p[0] == NULL)
					return -1;
				for (i = 0; i < 32; i++)
					q[0][i] = p[0][i];
			}
			if (q[1] != NULL) {
				if (p[1] == NULL)
					return -1;
				for (i = 0; i < 32; i++)
					q[1][i] = p[1][i];
			}
		}
	}
	return dsize;
}
